module apb_mux (input logic [31:0]  prdata_regs,
                input logic         pslverr_regs,
                input logic         pready_regs,
                input logic [31:0]  prdata_uart,
                input logic         pslverr_uart,
                input logic         pready_uart,
                input logic [31:0]  prdata_spi,
                input logic         pslverr_spi,
                input logic         pready_spi,
                input logic [31:0]  prdata_i2c,
                input logic         pslverr_i2c,
                input logic         pready_i2c,
                input logic [31:0]  prdata_cordic,
                input logic         pslverr_cordic,
                input logic         pready_cordic,
                input logic         sel_regs,
                input logic         sel_uart,
                input logic         sel_spi,
                input logic         sel_i2c,
                input logic         sel_cordic,
                output logic [31:0] prdata,
                output logic        psvlerr,
                output logic        pready);

//read access on test regs
function is_regs();
   return sel_regs;
endfunction   

//read access on uart
function is_uart();
   return sel_uart;
endfunction   

//read access on spi
function is_spi();
   return sel_spi;
endfunction   

//read access on i2c
function is_i2c();
   return sel_i2c;
endfunction     

//read access on i2c2
function is_cordic();
   return sel_cordic;
endfunction           
 
always_comb begin
   if(is_regs())
   begin
      prdata = prdata_regs;
      psvlerr = pslverr_regs;
      pready = pready_regs;
   end
   else if(is_uart())
   begin
      prdata = prdata_uart;
      psvlerr = pslverr_uart;
      pready = pready_uart;
   end 
   else if(is_spi())
   begin
      prdata = prdata_spi;
      psvlerr = pslverr_spi;
      pready = pready_spi;
   end 
   else if(is_i2c())
   begin
      prdata = prdata_i2c;
      psvlerr = pslverr_i2c;
      pready = pready_i2c;
   end 
   else if(is_cordic())
   begin
      prdata = prdata_cordic;
      psvlerr = pslverr_cordic;
      pready = pready_cordic;
   end 
   else
   begin
      prdata = 32'b0;
      psvlerr = 1'b0;
      pready = 1'b0;
   end
end

endmodule
