module cordic_addsub
#()
(
  // Group: A and B inputs
  // Inputs:
  //    A - operand a
  //    B - operand b
  `ifdef CORDIC_16
  input shortint             A_i,  
  input shortint             B_i,
  `elsif CORDIC_8
  input byte                 A_i,  
  input byte                 B_i,
  `else
  input int                  A_i,  
  input int                  B_i,
  `endif
  // Group: sel input
  // Inputs:
  //    sel - add or sub
  input logic                sel,
  // Group: X, Y and Z outputs
  // Outputs:
  //    C - result
  `ifdef CORDIC_16
  output shortint            C_o
  `elsif CORDIC_8
  output byte                C_o
  `else
  output int                 C_o  
  `endif
);


always_comb
  case(sel)
    1'b0 : C_o = A_i - B_i;
    1'b1 : C_o = A_i + B_i;
    default : C_o = A_i + B_i;
  endcase 

endmodule 
