module cordic_addsub_z
#(
  parameter integer unsigned WIDTH = 32
)
(
  // Group: A and B inputs
  // Inputs:
  //    A - operand a
  //    B - operand b
  input logic [WIDTH-1:0]    A_i,  
  input logic [WIDTH-1:0]    B_i, 
  // Group: sel input
  // Inputs:
  //    sel - add or sub
  input logic                sel,
  // Group: X, Y and Z outputs
  // Outputs:
  //    C - result
  output logic [WIDTH-1:0]   C_o  
);


always_comb
  case(sel)
    1'b0 : C_o = A_i - B_i;
    1'b1 : C_o = A_i + B_i;
    default : C_o = A_i + B_i;
  endcase 

endmodule 
