module cordic_pre
#(
  parameter integer unsigned WIDTH = 32
)
(
  // Group: Z input
  // Inputs:
  //    Z - 
  input logic [WIDTH-1:0]    Z_i,
  // Group: neg and Z output
  // Outputs:
  //    Z - 
  //    neg - results have to be negated if 1'b1
  output logic [WIDTH-1:0]   Z_o,
  output logic               neg   
);

//support signals
logic [WIDTH-1:0] ninety, two_seventy, rotate;
assign ninety = {4'b0100,{WIDTH-4{1'b0}}};
assign two_seventy = {4'b1100,{WIDTH-4{1'b0}}};
assign rotate = {4'b1000,{WIDTH-4{1'b0}}};

always_comb
begin
  if(Z_i > ninety & Z_i < two_seventy)
  begin
     Z_o = Z_i + rotate;
     neg = 1'b1;
  end
  else 
  begin
    Z_o = Z_i;
    neg = 1'b0;
  end
end

endmodule
