`timescale 1 ns/10 ps  // time-unit = 1 ns, precision = 10 ps

module test_regs (input logic                      CLK,
                  input logic                      RSTn,
                  input logic                      PSEL,
                  input logic                      PENABLE,
                  input logic [31:0]               PADDR,
                  input logic                      PWRITE,
                  input logic [31:0]               PWDATA,
                  output logic                     running,
                  output logic                     outcome,
                  output logic [13:0]              out,
                  input logic  [15:0]              in,
                  output logic                     PREADY,
                  output logic                     PSLVERR,
                  output logic [31:0]              PRDATA
);

/////////////////////////internal signals&regs///////////////////////////////////////
logic [15:0] regs [1:0];

/////////////////////////functions//////////////////////////////////////////////////
//read access
function is_read();
   return PSEL & PENABLE & ~PWRITE;
endfunction

//write access
function is_write();
   return PSEL & PENABLE & PWRITE;
endfunction

/////////////////////////signal assignment//////////////////////////////////////////
assign PREADY = 1;
assign PSLVERR = 0;    

assign running = regs[0][0];
assign outcome = regs[0][1];
assign out     = regs[0][15:2];

always_comb begin
   if(is_read())
   begin
      if(PADDR == 32'h00000000)
         PRDATA = {16'b0,regs[0]};
      else if(PADDR == 32'h00000004)
         PRDATA = {16'b0,regs[1]};
      else 
      PRDATA = 32'b0;
    end  
      else
         PRDATA = 32'b0;
end

always_ff @(posedge CLK or negedge RSTn)
   if(!RSTn)
      regs = '{default:'0};
   else begin
      regs[1] = in;
      if(is_write())
         if(PADDR == 32'h00000000)
            regs[0] = PWDATA[15:0];
   end 
   
endmodule
