## This file is a general .xdc for the Arty A7-100 Rev. D
## To use it in a project:
## - uncomment the lines corresponding to used pins
## - rename the used ports (in each line, after get_ports) according to the top level signal names in the project


# Clock signal

set_property -dict { PACKAGE_PIN E3    IOSTANDARD LVCMOS33 } [get_ports { CLK100MHZ }];
create_clock -add -name sys_clk_pin -period 10.000 -waveform {0.000 5.000} [get_ports {CLK100MHZ}];

#Switches
#Reset signals
set_property -dict { PACKAGE_PIN A8    IOSTANDARD LVCMOS33 } [get_ports { RST_POR_N }]; #IO_L12N_T1_MRCC_16 Sch=sw[0]
set_property -dict { PACKAGE_PIN C11   IOSTANDARD LVCMOS33 } [get_ports { RST_N }]; #IO_L13P_T2_MRCC_16 Sch=sw[1]
#set_property -dict { PACKAGE_PIN G2   IOSTANDARD LVCMOS33 } [get_ports { RST_N }]; #IO_L13P_T2_MRCC_16 Sch=sw[1]
#set_property PULLUP true [get_ports {RST_N}]

#LED's
#Check signals
set_property -dict { PACKAGE_PIN H5    IOSTANDARD LVCMOS33 } [get_ports { RUNNING }]; #IO_L24N_T3_35 Sch=led[4]
set_property -dict { PACKAGE_PIN J5    IOSTANDARD LVCMOS33 } [get_ports { OUTCOME }]; #IO_25_35 Sch=led[5]

#Buttons
set_property -dict { PACKAGE_PIN C10   IOSTANDARD LVCMOS33 } [get_ports { IN[0] }]; #IO_L13N_T2_MRCC_16 Sch=sw[2]
set_property -dict { PACKAGE_PIN A10   IOSTANDARD LVCMOS33 } [get_ports { IN[1] }]; #IO_L14P_T2_SRCC_16 Sch=sw[3]

#Pmod Header JA
set_property -dict { PACKAGE_PIN G13   IOSTANDARD LVCMOS33 } [get_ports { IRQ[0] }]; #IO_0_15 Sch=ja[1]
set_property -dict { PACKAGE_PIN B11   IOSTANDARD LVCMOS33 } [get_ports { IRQ[1] }]; #IO_L4P_T0_15 Sch=ja[2]
set_property -dict { PACKAGE_PIN A11   IOSTANDARD LVCMOS33 } [get_ports { IRQ[2] }]; #IO_L4N_T0_15 Sch=ja[3]
set_property -dict { PACKAGE_PIN D12   IOSTANDARD LVCMOS33 } [get_ports { IRQ[3] }]; #IO_L6P_T0_15 Sch=ja[4]
set_property -dict { PACKAGE_PIN D13   IOSTANDARD LVCMOS33 } [get_ports { IRQ[4] }]; #IO_L6N_T0_VREF_15 Sch=ja[7]
set_property -dict { PACKAGE_PIN B18   IOSTANDARD LVCMOS33 } [get_ports { IRQ[5] }]; #IO_L10P_T1_AD11P_15 Sch=ja[8]
set_property -dict { PACKAGE_PIN A18   IOSTANDARD LVCMOS33 } [get_ports { IRQ[6] }]; #IO_L10N_T1_AD11N_15 Sch=ja[9]
set_property -dict { PACKAGE_PIN E15   IOSTANDARD LVCMOS33 } [get_ports { IRQ[7] }]; #IO_L11P_T1_SRCC_15 Sch=ja[10]
set_property PULLDOWN true [get_ports {IRQ[0]}]
set_property PULLDOWN true [get_ports {IRQ[1]}]
set_property PULLDOWN true [get_ports {IRQ[2]}]
set_property PULLDOWN true [get_ports {IRQ[3]}]
set_property PULLDOWN true [get_ports {IRQ[4]}]
set_property PULLDOWN true [get_ports {IRQ[5]}]
set_property PULLDOWN true [get_ports {IRQ[6]}]
set_property PULLDOWN true [get_ports {IRQ[7]}]

#Pmod Header JB
set_property -dict { PACKAGE_PIN D15   IOSTANDARD LVCMOS33 } [get_ports { IRQ[8] }]; #IO_L12P_T1_MRCC_15 Sch=jb[1]
set_property -dict { PACKAGE_PIN C15   IOSTANDARD LVCMOS33 } [get_ports { IRQ[9] }]; #IO_L12N_T1_MRCC_15 Sch=jb[2]
set_property -dict { PACKAGE_PIN F18   IOSTANDARD LVCMOS33 } [get_ports { IRQ[10] }]; #IO_L22N_T3_A16_15 Sch=jb[3]
set_property -dict { PACKAGE_PIN J17   IOSTANDARD LVCMOS33 } [get_ports { IRQ[11] }]; #IO_L23P_T3_FOE_B_15 Sch=jb[4]
set_property -dict { PACKAGE_PIN J18   IOSTANDARD LVCMOS33 } [get_ports { IRQ[12] }]; #IO_L23N_T3_FWE_B_15 Sch=jb[7]
set_property -dict { PACKAGE_PIN K15   IOSTANDARD LVCMOS33 } [get_ports { IRQ[13] }]; #IO_L24P_T3_RS1_15 Sch=jb[8]
set_property -dict { PACKAGE_PIN J15   IOSTANDARD LVCMOS33 } [get_ports { IRQ[14] }]; #IO_L24N_T3_RS0_15 Sch=jb[9]
set_property -dict { PACKAGE_PIN K16   IOSTANDARD LVCMOS33 } [get_ports { IRQ[15] }]; #IO_25_15 Sch=jb[10]
set_property PULLDOWN true [get_ports {IRQ[8]}]
set_property PULLDOWN true [get_ports {IRQ[9]}]
set_property PULLDOWN true [get_ports {IRQ[10]}]
set_property PULLDOWN true [get_ports {IRQ[11]}]
set_property PULLDOWN true [get_ports {IRQ[12]}]
set_property PULLDOWN true [get_ports {IRQ[13]}]
set_property PULLDOWN true [get_ports {IRQ[14]}]
set_property PULLDOWN true [get_ports {IRQ[15]}]

#Pmod Header JC
set_property -dict { PACKAGE_PIN U12   IOSTANDARD LVCMOS33 } [get_ports { IRQ[16] }]; #IO_L20P_T3_A08_D24_14 Sch=jc[1]
set_property -dict { PACKAGE_PIN U12   IOSTANDARD LVCMOS33 } [get_ports { IRQ[16] }]; #IO_L20P_T3_A08_D24_14 Sch=jc[1]
set_property -dict { PACKAGE_PIN V12   IOSTANDARD LVCMOS33 } [get_ports { IRQ[17] }]; #IO_L20N_T3_A07_D23_14 Sch=jc[2]
set_property -dict { PACKAGE_PIN V10   IOSTANDARD LVCMOS33 } [get_ports { IRQ[18] }]; #IO_L21P_T3_DQS_14 Sch=jc[3]
set_property -dict { PACKAGE_PIN V11   IOSTANDARD LVCMOS33 } [get_ports { IRQ[19] }]; #IO_L21N_T3_DQS_A06_D22_14 Sch=jc[4]
set_property -dict { PACKAGE_PIN U14   IOSTANDARD LVCMOS33 } [get_ports { IRQ[20] }]; #IO_L22P_T3_A05_D21_14 Sch=jc[7]
set_property -dict { PACKAGE_PIN V14   IOSTANDARD LVCMOS33 } [get_ports { IRQ[21] }]; #IO_L22N_T3_A04_D20_14 Sch=jc[8]
set_property -dict { PACKAGE_PIN T13   IOSTANDARD LVCMOS33 } [get_ports { IRQ[22] }]; #IO_L23P_T3_A03_D19_14 Sch=jc[9]
set_property -dict { PACKAGE_PIN U13   IOSTANDARD LVCMOS33 } [get_ports { IRQ[23] }]; #IO_L23N_T3_A02_D18_14 Sch=jc[10]
set_property PULLDOWN true [get_ports {IRQ[16]}]
set_property PULLDOWN true [get_ports {IRQ[17]}]
set_property PULLDOWN true [get_ports {IRQ[18]}]
set_property PULLDOWN true [get_ports {IRQ[19]}]
set_property PULLDOWN true [get_ports {IRQ[20]}]
set_property PULLDOWN true [get_ports {IRQ[21]}]
set_property PULLDOWN true [get_ports {IRQ[22]}]
set_property PULLDOWN true [get_ports {IRQ[23]}]

#ChipKit Digital I/O low
set_property -dict { PACKAGE_PIN V15    IOSTANDARD LVCMOS33 } [get_ports { IRQ[24] }]; #IO_L11N_T1_SRCC_35 Sch=jd[1]
set_property -dict { PACKAGE_PIN U16    IOSTANDARD LVCMOS33 } [get_ports { IRQ[25] }]; #IO_L12N_T1_MRCC_35 Sch=jd[2]
set_property -dict { PACKAGE_PIN T11    IOSTANDARD LVCMOS33 } [get_ports { IRQ[26] }]; #IO_L13P_T2_MRCC_35 Sch=jd[3]
set_property -dict { PACKAGE_PIN R12    IOSTANDARD LVCMOS33 } [get_ports { IRQ[27] }]; #IO_L13N_T2_MRCC_35 Sch=jd[4]
set_property -dict { PACKAGE_PIN T14    IOSTANDARD LVCMOS33 } [get_ports { IRQ[28] }]; #IO_L14P_T2_SRCC_35 Sch=jd[7]
set_property -dict { PACKAGE_PIN T15    IOSTANDARD LVCMOS33 } [get_ports { IRQ[29] }]; #IO_L14N_T2_SRCC_35 Sch=jd[8]
set_property -dict { PACKAGE_PIN T16    IOSTANDARD LVCMOS33 } [get_ports { IRQ[30] }]; #IO_L15P_T2_DQS_35 Sch=jd[9]
set_property -dict { PACKAGE_PIN N15    IOSTANDARD LVCMOS33 } [get_ports { IRQ[31] }]; #IO_L15N_T2_DQS_35 Sch=jd[10]
set_property PULLDOWN true [get_ports {IRQ[24]}]
set_property PULLDOWN true [get_ports {IRQ[25]}]
set_property PULLDOWN true [get_ports {IRQ[26]}]
set_property PULLDOWN true [get_ports {IRQ[27]}]
set_property PULLDOWN true [get_ports {IRQ[28]}]
set_property PULLDOWN true [get_ports {IRQ[29]}]
set_property PULLDOWN true [get_ports {IRQ[30]}]
set_property PULLDOWN true [get_ports {IRQ[31]}]

#JTAG, mapped on port JD
set_property -dict { PACKAGE_PIN F4   IOSTANDARD LVCMOS33 } [get_ports { JTCK }]; #IO_L8N_T1_D12_14 Sch=ck_io[2]
set_property -dict { PACKAGE_PIN D4   IOSTANDARD LVCMOS33 } [get_ports { JTDI }]; #IO_L19P_T3_A10_D26_14 Sch=ck_io[3]
set_property -dict { PACKAGE_PIN D3   IOSTANDARD LVCMOS33 } [get_ports { JTMS }]; #IO_L5P_T0_D06_14 Sch=ck_io[4]
set_property -dict { PACKAGE_PIN F3   IOSTANDARD LVCMOS33 } [get_ports { JTDO }]; #IO_L14P_T2_SRCC_14 Sch=ck_io[5]
set_property -dict { PACKAGE_PIN E2   IOSTANDARD LVCMOS33 } [get_ports { TDOEN_N }]; #IO_L14N_T2_SRCC_14 Sch=ck_io[6]
#create_clock -add -name jtag_clk_pin -period 200000.000 -waveform {0.000 100000.000} [get_ports {JTCK}];
set_property PULLUP true [get_ports {JTDI}]
set_property PULLUP true [get_ports {JTMS}]
set_property PULLUP true [get_ports {JTDO}]

#scan mode and scan enable, mapped on Port JD
#set_property -dict { PACKAGE_PIN D2   IOSTANDARD LVCMOS33 } [get_ports { SCANMODE }]; #IO_L16P_T2_CSI_B_14 Sch=ck_io[0]
#set_property -dict { PACKAGE_PIN H2   IOSTANDARD LVCMOS33 } [get_ports { SCAN_ENABLE }]; #IO_L18P_T2_A12_D28_14 Sch=ck_io[1]
#set_property PULLDOWN true [get_ports {SCANMODE}]
#set_property PULLDOWN true [get_ports {SCAN_ENABLE}]

#USB-UART Interface
set_property -dict { PACKAGE_PIN D10   IOSTANDARD LVCMOS33 } [get_ports { TX }]; 
set_property -dict { PACKAGE_PIN A9    IOSTANDARD LVCMOS33 } [get_ports { RX }]; 

#SPI Interface
#set_property -dict { PACKAGE_PIN U11   IOSTANDARD LVCMOS33 } [get_ports { SSEL_OUT }]; #IO_L19N_T3_A09_D25_VREF_14 Sch=ck_io[26]
set_property -dict { PACKAGE_PIN C1   IOSTANDARD LVCMOS33 } [get_ports { SSEL_OUT }]; #IO_L19N_T3_A09_D25_VREF_14 Sch=ck_io[26]
#set_property -dict { PACKAGE_PIN V16   IOSTANDARD LVCMOS33 } [get_ports { SCLKO }]; #IO_L16N_T2_A15_D31_14 Sch=ck_io[27]
set_property -dict { PACKAGE_PIN F1  IOSTANDARD LVCMOS33 } [get_ports { SCLKO }]; #IO_L16N_T2_A15_D31_14 Sch=ck_io[27]
#create_clock -add -name spi_clk_pin -period 400.000 -waveform {0.000 200.000} [get_ports {SCLKO}];
#set_property -dict { PACKAGE_PIN M13   IOSTANDARD LVCMOS33 } [get_ports { SDO }]; #IO_L6N_T0_D08_VREF_14 Sch=ck_io[28]
set_property -dict { PACKAGE_PIN H1   IOSTANDARD LVCMOS33 } [get_ports { SDO }]; #IO_L6N_T0_D08_VREF_14 Sch=ck_io[28]


set_property -dict { PACKAGE_PIN U11   IOSTANDARD LVCMOS33 } [get_ports { SSEL_IN }]; #IO_25_14 Sch=ck_io[26]
set_property -dict { PACKAGE_PIN V16   IOSTANDARD LVCMOS33 } [get_ports { SCLK_IN }]; #IO_0_14 Sch=ck_io[27]
set_property -dict { PACKAGE_PIN M13   IOSTANDARD LVCMOS33 } [get_ports { SDI }]; #IO_L5N_T0_D07_14 Sch=ck_io[28]

#set_clock_sense -negative xriscv_sys/xrv32_uc/xrvdm_top/cluster_tap_i/latched_jtag_ir[3]_i_3/O

#set_clock_groups -async -group [get_clocks jtag_clk_pin]
#set_clock_groups -async -group [get_clocks sys_clk_pin]
#set_clock_groups -async -group [get_clocks spi_clk_pin]

