module apb_demux (input logic         penable,
                  input logic         pwrite,
                  input logic         psel,
                  input logic         sel_regs,
                  input logic         sel_uart,
                  input logic         sel_spi,
                  input logic         sel_i2c,
                  input logic         sel_cordic,
                  output logic        penable_regs,
                  output logic        pwrite_regs,
                  output logic        psel_regs,
                  output logic        penable_uart,
                  output logic        pwrite_uart,
                  output logic        psel_uart,
                  output logic        penable_spi,
                  output logic        pwrite_spi,
                  output logic        psel_spi,
                  output logic        penable_i2c,
                  output logic        pwrite_i2c,
                  output logic        psel_i2c,
                  output logic        penable_cordic,
                  output logic        pwrite_cordic,
                  output logic        psel_cordic);

//read access on test regs
function is_regs();
   return sel_regs;
endfunction   

//read access on uart
function is_uart();
   return sel_uart;
endfunction    

//read access on spi
function is_spi();
   return sel_spi;
endfunction       
 
//read access on i2c
function is_i2c();
   return sel_i2c;
endfunction     

//read access on i2c2
function is_cordic();
   return sel_cordic;
endfunction       
 
always_comb begin
   if(is_regs())
   begin
      penable_regs   = penable;
      pwrite_regs    = pwrite;
      psel_regs      = psel;
      penable_uart   = 1'b0;
      pwrite_uart    = 1'b0;
      psel_uart      = 1'b0;
      penable_spi    = 1'b0;
      pwrite_spi     = 1'b0;
      psel_spi       = 1'b0;
      penable_i2c    = 1'b0;
      pwrite_i2c     = 1'b0;
      psel_i2c       = 1'b0;
      penable_cordic = 1'b0;
      pwrite_cordic  = 1'b0;
      psel_cordic    = 1'b0;
   end
   else if(is_uart())
   begin
      penable_regs   = 1'b0;
      pwrite_regs    = 1'b0;
      psel_regs      = 1'b0;
      penable_uart   = penable;
      pwrite_uart    = pwrite;
      psel_uart      = psel;
      penable_spi    = 1'b0;
      pwrite_spi     = 1'b0;
      psel_spi       = 1'b0;
      penable_i2c    = 1'b0;
      pwrite_i2c     = 1'b0;
      psel_i2c       = 1'b0;
      penable_cordic = 1'b0;
      pwrite_cordic  = 1'b0;
      psel_cordic    = 1'b0;
   end 
   else if(is_spi())
   begin
      penable_regs   = 1'b0;
      pwrite_regs    = 1'b0;
      psel_regs      = 1'b0;
      penable_uart   = 1'b0;
      pwrite_uart    = 1'b0;
      psel_uart      = 1'b0;
      penable_spi    = penable;
      pwrite_spi     = pwrite;
      psel_spi       = psel;
      penable_i2c    = 1'b0;
      pwrite_i2c     = 1'b0;
      psel_i2c       = 1'b0;
      penable_cordic = 1'b0;
      pwrite_cordic  = 1'b0;
      psel_cordic    = 1'b0;
   end 
   else if(is_i2c())
   begin
      penable_regs   = 1'b0;
      pwrite_regs    = 1'b0;
      psel_regs      = 1'b0;
      penable_uart   = 1'b0;
      pwrite_uart    = 1'b0;
      psel_uart      = 1'b0;
      penable_spi    = 1'b0;
      pwrite_spi     = 1'b0;
      psel_spi       = 1'b0;
      penable_i2c    = penable;
      pwrite_i2c     = pwrite;
      psel_i2c       = psel;
      penable_cordic = 1'b0;
      pwrite_cordic  = 1'b0;
      psel_cordic    = 1'b0;
   end 
   else if(is_cordic())
   begin
      penable_regs   = 1'b0;
      pwrite_regs    = 1'b0;
      psel_regs      = 1'b0;
      penable_uart   = 1'b0;
      pwrite_uart    = 1'b0;
      psel_uart      = 1'b0;
      penable_spi    = 1'b0;
      pwrite_spi     = 1'b0;
      psel_spi       = 1'b0;
      penable_i2c    = 1'b0;
      pwrite_i2c     = 1'b0;
      psel_i2c       = 1'b0;
      penable_cordic = penable;
      pwrite_cordic  = pwrite;
      psel_cordic    = psel;
   end 
   else
   begin
      penable_regs   = 1'b0;
      pwrite_regs    = 1'b0;
      psel_regs      = 1'b0;
      penable_uart   = 1'b0;
      pwrite_uart    = 1'b0;
      psel_uart      = 1'b0;
      penable_spi    = 1'b0;
      pwrite_spi     = 1'b0;
      psel_spi       = 1'b0;
      penable_i2c    = 1'b0;
      pwrite_i2c     = 1'b0;
      psel_i2c       = 1'b0;
      penable_cordic = 1'b0;
      pwrite_cordic  = 1'b0;
      psel_cordic    = 1'b0;
   end
end

endmodule
