`timescale 1ns/100ps
//fully synchronous ram model
//numByte is the number of Bytes of the memory (128 KiB  = 128*1024 Bytes according to the specs in riscv_1_gp_01)
module ram #(parameter numByte = 128*1024)
            (input logic ram0_clk,
             input logic ram0_ce,
             input logic ram0_we,
             input logic[3:0] ram0_be,
             input logic[($clog2(numByte)-2)-1:0] ram0_addr,
             input logic[31:0] ram0_wdata,
             output logic[31:0] ram0_rdata);
             
//parameter INIT_FILE = "";
//128 KiB = 4 * 32 KiB => each memory location is made of 32 bits (1 word) instead of 1 byte
//(* ram_style = "block" *) logic[31:0] ram[(1<<(($clog2(numByte))-2))-1:0];
logic[31:0] ram[(1<<(($clog2(numByte))-2))-1:0];

//parameter ram_INIT_FILE = "";

//initial begin
//$readmemh(ram_INIT_FILE, ram, 0, (1<<(($clog2(numByte))-2))-1);
//end

initial begin
$readmemh("C:/Users/federico.pozzana/Desktop/rv_digtop/rv_digtop.ip_user_files/mem_init_files/init_ram.mem", ram);
end
//write capability
//a memory location is written if
//ram0_ce and ram0_we are high
//the corresponding bit in ram0_be is high
always_ff @(posedge ram0_clk) begin
  if (ram0_ce) begin
    if (ram0_we)
      if (ram0_be[0])
        ram[ram0_addr][7:0] <= ram0_wdata[7:0];
      if (ram0_be[1])
        ram[ram0_addr][15:8] <= ram0_wdata[15:8];
      if (ram0_be[2])
        ram[ram0_addr][23:16] <= ram0_wdata[23:16];
      if (ram0_be[3])
        ram[ram0_addr][31:24] <= ram0_wdata[31:24];
    end
end

//read capability
//read the complete word if ram0_ce is high
always_ff @(posedge ram0_clk) begin
  if (ram0_ce)
    ram0_rdata <= ram[ram0_addr];
end

endmodule
