#ifndef PULPINO_H
#define PULPINO_H

#define PULPINO_BASE_ADDR             0x0

/** SOC PERIPHERALS */
#define SOC_PERIPHERALS_BASE_ADDR     ( PULPINO_BASE_ADDR + 0x40000000 )
#define SOC_PERIPHERALS_END_TEST_ADDR ( PULPINO_BASE_ADDR + 0x40010000 )
#define SOC_PERIPHERALS_END_ADDR      ( PULPINO_BASE_ADDR + 0x400FFFFF )

#define RF_BASE_ADDR                  ( SOC_PERIPHERALS_BASE_ADDR + 0x0000 )

#define INTERRUPT_BASE_ADDR           ( PULPINO_BASE_ADDR + 0x40036000 )
#define INTERRUPT_END_ADDR            ( PULPINO_BASE_ADDR + 0x400363FF )

/** TEST REGS */
#define CHECK_REG_TEST                ( SOC_PERIPHERALS_BASE_ADDR + 0x8000 )
#define CHECK_REG_INPUT               ( SOC_PERIPHERALS_BASE_ADDR + 0x8004 )

#define test_check                    REG(CHECK_REG_TEST)
#define test_input                    REG(CHECK_REG_INPUT)
//////////////////////////////////////////////////////////////////////////////////////
/** PERIPHERALS START ADDRESS */
//#define UART_BASE_ADDR                ( SOC_PERIPHERALS_BASE_ADDR + 0x4000 )
//#define CPU_FREQ_HZ                   10000000
//#define BAUD_RATE                     9600
//#define UART_DIV                      CPU_FREQ_HZ/BAUD_RATE

//#define SPI_BASE_ADDR                 ( SOC_PERIPHERALS_BASE_ADDR + 0x2000 )

//#define I2C_BASE_ADDR                 ( SOC_PERIPHERALS_BASE_ADDR + 0x1000 )
//#define I2C_BASE_ADDR2                ( SOC_PERIPHERALS_BASE_ADDR + 0x0800 )
//////////////////////////////////////////////////////////////////////////////////////
/** PERIPHERALS START ADDRESS */
#define UART_BASE_ADDR                ( SOC_PERIPHERALS_BASE_ADDR + 0x4000 )
#define CPU_FREQ_HZ                   1000000
#define BAUD_RATE                     115200
#define BAUD_RATE_9600                9600
#define BAUD_RATE_14400               14400
#define BAUD_RATE_19200               19200
#define BAUD_RATE_38400               38400
#define BAUD_RATE_57600               57600
#define UART_DIV                      CPU_FREQ_HZ/BAUD_RATE
#define UART_DIV_9600                 CPU_FREQ_HZ/BAUD_RATE_9600
#define UART_DIV_14400                CPU_FREQ_HZ/BAUD_RATE_14400
#define UART_DIV_19200                CPU_FREQ_HZ/BAUD_RATE_19200
#define UART_DIV_38400                CPU_FREQ_HZ/BAUD_RATE_38400
#define UART_DIV_57600                CPU_FREQ_HZ/BAUD_RATE_57600

#define SPI_BASE_ADDR                 ( SOC_PERIPHERALS_BASE_ADDR + 0x2000 )

#define I2C_BASE_ADDR                 ( SOC_PERIPHERALS_BASE_ADDR + 0x1000 )

#define CORDIC_BASE_ADDR              ( SOC_PERIPHERALS_BASE_ADDR + 0x0800 )

#define I2C_BASE_ADDR2                ( SOC_PERIPHERALS_BASE_ADDR + 0x0400 )

/** Registers and pointers */
#define REGP(x) ((volatile unsigned int*)(x))
#define REG(x) (*((volatile unsigned int*)(x)))
#define REGP_8(x) (((volatile uint8_t*)(x)))

#define BYTE unsigned short
#define HALF_WORD unsigned int
#define WORD unsigned long long

#define INSTRUCTION_LENGHT 16

#endif /* PULPINO_H_ */
