/*
 * interrupt_handlers.c
 *
 *  Created on: 28 mag 2020
 *      Author: Federico.Pozzana
 */

#include "interrupt_handlers.h"
#include "riscv_1_gp_01.h"
#include "core_rv32.h"

#include "uart.h"

/////////////////////lfsr start//////////////////////////////////////////////

static HALF_WORD lfsr = 0xACE1;
static HALF_WORD mask = 0xB400;

/////////////////////////////////////////////////////////////////////////////

HALF_WORD lfsr_16(HALF_WORD lfsr, HALF_WORD mask){
	int lsb;

	lsb = lfsr & 1;
	lfsr >>= 1;

	if (lsb == 1){
		lfsr ^= mask;
	}

	return lfsr;
}

/////////////////////////////////////////////////////////////////////////////

char instruction[INSTRUCTION_LENGHT];
BYTE instruction_ready;

void enable_interrupt(void) {
	IER = 0xFFFFFFFF;
}

void disable_interrupt(void) {
	IER = 0x00000000;
}

void enable_event(void) {
	EER = 0xFFFFFFFF;
}

void disable_event(void) {
	EER = 0x00000000;
}

//ICP = ICP | something => clear interrupt, not global (interrupt clear pending)

void  __attribute__((interrupt("machine")))
PowerFail_Handler(void) {
   //Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000001;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
BusError_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000002;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_02_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000004;
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////UART slave//////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
/*
	BYTE data;
	BYTE data2;
	BYTE data3;
	BYTE data4;
	BYTE data5;
	BYTE data6;
	BYTE data7;
	BYTE data8;
	int operation;
	int next_thd;

	clear_rx_fifo_thd_int();
	lfsr = lfsr_16(lfsr, mask);
	lfsr_next = lfsr_16(lfsr_next, mask);
	operation = (lfsr & 0x0007);
	next_thd = (lfsr_next & 0x0007);

	switch(operation)
	{
	case 0 : data = recieve_uart();

			if(data != (lfsr & 0x00ff)){
				test_check = 0x02;
			}

			 break;
	case 1 : data = recieve_uart();
			 data2 = recieve_uart();

			 if(data != (lfsr & 0x00ff) & data2 != ((lfsr & 0x01fe) >> 1)){
			 		test_check = 0x02;
		  	 }

			 break;
	case 2 : data = recieve_uart();
			 data2 = recieve_uart();
			 data3 = recieve_uart();

			 if(data != (lfsr & 0x00ff) & data2 != ((lfsr & 0x01fe) >> 1) & data3 != ((lfsr & 0x03fc) >> 2)){
				 test_check = 0x02;
			 }

			 break;
	case 3 : data = recieve_uart();
			 data2 = recieve_uart();
			 data3 = recieve_uart();
			 data4 = recieve_uart();

			 if(data != (lfsr & 0x00ff) & data2 != ((lfsr & 0x01fe) >> 1) & data3 != ((lfsr & 0x03fc) >> 2) & data4 != ((lfsr & 0x07f8) >> 3)){
			 	 test_check = 0x02;
			 }

			 break;
	case 4 : data = recieve_uart();
	 	 	 data2 = recieve_uart();
	 	 	 data3 = recieve_uart();
	 	 	 data4 = recieve_uart();
	 	 	 data5 = recieve_uart();

		    if(data != (lfsr & 0x00ff) & data2 != ((lfsr & 0x01fe) >> 1) & data3 != ((lfsr & 0x03fc) >> 2) & data4 != ((lfsr & 0x07f8) >> 3) & data4 != ((lfsr & 0x0ff0) >> 4) & data5 != ((lfsr & 0x1fe0) >> 5)){
				test_check = 0x02;
			}

			 break;
	case 5 : data = recieve_uart();
 	 	 	 data2 = recieve_uart();
 	 	 	 data3 = recieve_uart();
 	 	 	 data4 = recieve_uart();
 	 	 	 data5 = recieve_uart();
 	 	 	 data6 = recieve_uart();

 	 	 	if(data != (lfsr & 0x00ff) & data2 != ((lfsr & 0x01fe) >> 1) & data3 != ((lfsr & 0x03fc) >> 2) & data4 != ((lfsr & 0x07f8) >> 3) & data4 != ((lfsr & 0x0ff0) >> 4) & data5 != ((lfsr & 0x1fe0) >> 5) & data6 != ((lfsr & 0x3fc0) >> 6)){
			 		test_check = 0x02;
		  	 }

			 break;
	case 6 : data = recieve_uart();
	 	 	 data2 = recieve_uart();
	 	 	 data3 = recieve_uart();
	 	 	 data4 = recieve_uart();
	 	 	 data5 = recieve_uart();
	 	 	 data6 = recieve_uart();
	 	 	 data7 = recieve_uart();

	 	 	 if(data != (lfsr & 0x00ff) & data2 != ((lfsr & 0x01fe) >> 1) & data3 != ((lfsr & 0x03fc) >> 2) & data4 != ((lfsr & 0x07f8) >> 3) & data4 != ((lfsr & 0x0ff0) >> 4) & data5 != ((lfsr & 0x1fe0) >> 5) & data6 != ((lfsr & 0x3fc0) >> 6) & data7 != ((lfsr & 0x7f80) >> 7)){
				 test_check = 0x02;
			 }

			 break;
	case 7 : data = recieve_uart();
 	 	 	 data2 = recieve_uart();
 	 	 	 data3 = recieve_uart();
 	 	 	 data4 = recieve_uart();
 	 	 	 data5 = recieve_uart();
 	 	 	 data6 = recieve_uart();
 	 	 	 data7 = recieve_uart();
 	 	 	 data8 = recieve_uart();

	 	 	 if(data != (lfsr & 0x00ff) & data2 != ((lfsr & 0x01fe) >> 1) & data3 != ((lfsr & 0x03fc) >> 2) & data4 != ((lfsr & 0x07f8) >> 3) & data4 != ((lfsr & 0x0ff0) >> 4) & data5 != ((lfsr & 0x1fe0) >> 5) & data6 != ((lfsr & 0x3fc0) >> 6) & data7 != ((lfsr & 0x7f80) >> 7) & data8 != ((lfsr & 0xff00) >> 8)){
			 	 test_check = 0x02;
			 }

			 break;
	default : data = recieve_uart();
	 	 	  data2 = recieve_uart();
	 	 	  data3 = recieve_uart();
	 	 	  data4 = recieve_uart();

	 	 	 if(data != (lfsr & 0x00ff) & data2 != ((lfsr & 0x01fe) >> 1) & data3 != ((lfsr & 0x03fc) >> 2) & data4 != ((lfsr & 0x07f8) >> 3)){
	 	 		 test_check = 0x02;
	 	 	 }

	 	 	 break;
	}

	switch(next_thd)
		{
		case 0 : set_rx_fifo_thd(1);

				 break;
		case 1 : set_rx_fifo_thd(2);

				 break;
		case 2 : set_rx_fifo_thd(3);

				 break;
		case 3 : set_rx_fifo_thd(4);

				 break;
		case 4 : set_rx_fifo_thd(5);

				 break;
		case 5 : set_rx_fifo_thd(6);

				 break;
		case 6 : set_rx_fifo_thd(7);

				break;
		case 7 : set_rx_fifo_thd(8);

				 break;
		default : set_rx_fifo_thd(4);

		 	 	 break;
		}

	test_check ^= 0x01;
	test_check ^= 0x01;
*/
///////////////////////////////////////////////////////////////////////////////////////////
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_03_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000008;
	//this is uart.mem test
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_04_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000010;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_05_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000020;
	///////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////UART slave//////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////

		BYTE data;

		BYTE bytes;

		lfsr = lfsr_16(lfsr, mask);

		bytes = rx_fifo_bytes();

		for(int i = 0; i < bytes; i++){
			data = recieve_uart();
			switch(i)
			{
			case 0 : if(data != (lfsr & 0x003f)){
						test_check ^= 0x02;
					 }
					 break;
			case 1 : if(data != ((lfsr & 0x007e) >> 1)){
						test_check ^= 0x02;
					 }
					 break;
			case 2 : if(data != ((lfsr & 0x00fc) >> 2)){
						test_check ^= 0x02;
					 }
					 break;
			case 3 : if(data != ((lfsr & 0x01f8) >> 3)){
						test_check ^= 0x02;
					 }
					 break;
			case 4 : if(data != ((lfsr & 0x03f0) >> 4)){
						test_check ^= 0x02;
					 }
					 break;
			case 5 : if(data != ((lfsr & 0x07e0) >> 5)){
						test_check ^= 0x02;
					 }
					 break;
			case 6 : if(data != ((lfsr & 0x0fc0) >> 6)){
						test_check ^= 0x02;
					 }
					 break;
			case 7 : if(data != ((lfsr & 0x1f80) >> 7)){
						test_check ^= 0x02;
					 }
					 break;
			}
		}

		rx_flush();

		test_check ^= 0x01;
		test_check ^= 0x01;

	///////////////////////////////////////////////////////////////////////////////////////////
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_06_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000040;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_07_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000080;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_08_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000100;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_09_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000200;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_10_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000400;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_11_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00000800;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_12_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00001000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_13_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00002000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_14_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00004000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_15_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00008000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_16_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00010000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_17_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00020000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_18_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00040000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_19_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00080000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_20_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00100000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_21_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00200000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_22_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00400000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_23_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x00800000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_24_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x01000000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_25_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x02000000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_26_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x04000000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_27_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x08000000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_28_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x10000000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_29_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x20000000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_30_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x40000000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}

void  __attribute__((interrupt("machine")))
IRQ_31_Handler(void) {
	//Disable interrupts, clear flag and re-enable interrupts
	//__disable_irq();
	IER = 0x00000000;
	ICP = ICP | 0x80000000;
	IER = 0xFFFFFFFF;
	//__enable_irq();
}
