/*
 * cordic.c
 *
 *  Created on: 31 ago 2020
 *      Author: Federico.Pozzana
 */

#include "cordic.h"

void cordic_start_rot(){
	CTRL_CORDIC |= (1 << 0);
}

void cordic_start_vect(){
	CTRL_CORDIC |= (1 << 1);
}

void cordic_x_data_byte_write(sBYTE data){
	X_DATA_CORDIC = data;
}

void cordic_y_data_byte_write(sBYTE data){
	Y_DATA_CORDIC = data;
}

void cordic_z_data_byte_write(sBYTE data){
	Z_DATA_CORDIC = data;
}

void cordic_x_data_half_word_write(sHALF_WORD data){
	X_DATA_CORDIC = data;
}

void cordic_y_data_half_word_write(sHALF_WORD data){
	Y_DATA_CORDIC = data;
}

void cordic_z_data_half_word_write(sHALF_WORD data){
	Z_DATA_CORDIC = data;
}

void cordic_x_data_word_write(sWORD data){
	X_DATA_CORDIC = data;
}

void cordic_y_data_word_write(sWORD data){
	Y_DATA_CORDIC = data;
}

void cordic_z_data_word_write(sWORD data){
	Z_DATA_CORDIC = data;
}

sBYTE cordic_cos_byte_read(){
	return COS_CORDIC;
}

sBYTE cordic_sin_byte_read(){
	return SIN_CORDIC;
}

sHALF_WORD cordic_cos_half_word_read(){
	return COS_CORDIC;
}

sHALF_WORD cordic_sin_half_word_read(){
	return SIN_CORDIC;
}

sWORD cordic_cos_word_read(){
	return COS_CORDIC;
}

sWORD cordic_sin_word_read(){
	return SIN_CORDIC;
}

float degrees_to_radians(float angle){
	return ((angle * 3.141593)/180.0);
}

BYTE cordic_8_angle(float angle){
	return ((angle * 0xff)/360.0);
}

HALF_WORD cordic_16_angle(float angle){
	return ((angle * 0xffff)/360.0);
}

WORD cordic_32_angle(float angle){
	return ((angle * 0xffffffff)/360.0);
}

float cordic_8_sin(WORD angle){
	float sinus_cordic;
	sBYTE temp;
	int done = 0;

	cordic_x_data_word_write(cordic_8_const);
	cordic_y_data_word_write(0);
	cordic_z_data_word_write(angle);

	cordic_start_rot();

	//while(!done){
	//	temp = cordic_sin_byte_read();
	//	if(temp != 0){
	//		done = 1;
	//	}
	//}

	while(!cordic_polling()){}
	cordic_clear();

	temp = cordic_sin_half_word_read();
	sinus_cordic = temp / cordic_16_div;
	return (sinus_cordic);
}

float cordic_16_sin(WORD angle){
	float sinus_cordic;
	sHALF_WORD temp;
	//int done = 0;

	cordic_x_data_word_write(cordic_16_const);
	cordic_y_data_word_write(0);
	cordic_z_data_word_write(angle);

	cordic_start_rot();

	//while(!done){
	//	temp = cordic_sin_half_word_read();
	//	if(temp != 0){
	//		done = 1;
	//	}
	//}

	while(!cordic_polling()){}
	cordic_clear();

	temp = cordic_sin_half_word_read();
	sinus_cordic = temp / cordic_16_div;
	return (sinus_cordic);
}

float cordic_32_sin(WORD angle){
	float sinus_cordic;
	sWORD temp;
	int done = 0;

	cordic_x_data_word_write(cordic_32_const);
	cordic_y_data_word_write(0);
	cordic_z_data_word_write(angle);

	cordic_start_rot();

	//while(!done){
	//	temp = cordic_sin_word_read();
	//	if(temp != 0){
	//		done = 1;
	//	}
	//}

	while(!cordic_polling()){}
	cordic_clear();

	temp = cordic_sin_half_word_read();
	sinus_cordic = temp / cordic_16_div;
	return (sinus_cordic);
}

float cordic_8_cos(WORD angle){
	float cosine_cordic;
	sBYTE temp;
	int done = 0;

	cordic_x_data_word_write(cordic_8_const);
	cordic_y_data_word_write(0);
	cordic_z_data_word_write(angle);

	cordic_start_rot();

	//while(!done){
	//	temp = cordic_cos_byte_read();
	//	if(temp != 0){
	//		done = 1;
	//	}
	//}

	while(!cordic_polling()){}
	cordic_clear();

	temp = cordic_sin_half_word_read();
	cosine_cordic = temp / cordic_16_div;
	return (cosine_cordic);
}

float cordic_16_cos(WORD angle){
	float cosine_cordic;
	sHALF_WORD temp;
	//int done = 0;

	cordic_x_data_word_write(cordic_16_const);
	cordic_y_data_word_write(0);
	cordic_z_data_word_write(angle);

	cordic_start_rot();

	//while(!done){
	//	temp = cordic_cos_half_word_read();
	//	if(temp != 0){
	//		done = 1;
	//	}
	//}

	while(!cordic_polling()){}
	cordic_clear();

	temp = cordic_sin_half_word_read();
	cosine_cordic = temp / cordic_16_div;
	return (cosine_cordic);
}

float cordic_32_cos(WORD angle){
	float cosine_cordic;
	sWORD temp;
	int done = 0;

	cordic_x_data_word_write(cordic_32_const);
	cordic_y_data_word_write(0);
	cordic_z_data_word_write(angle);

	cordic_start_rot();

	//while(!done){
	//	temp = cordic_cos_word_read();
	//	if(temp != 0){
	//		done = 1;
	//	}
	//}

	while(!cordic_polling()){}
	cordic_clear();

	temp = cordic_sin_half_word_read();
	cosine_cordic = temp / cordic_16_div;
	return (cosine_cordic);
}

WORD cordic_polling(){
	return STAT_CORDIC;
}

void cordic_clear(){
	STAT_CORDIC |= (1 << 1);
}

float cordic_sqrt_half_word(int data){
	int n = 0;
	int even = 1;
	int tmp = data;
	sHALF_WORD temp;
	float result;
	HALF_WORD regx, regy;

	while(tmp > 0){
		tmp = tmp >> 1;
		n++;
		if(even){
			even--;
		}else{
			even++;
		}
	}

	if(even){
		regx = ((data << (15 - n - 2)) + cordic_16_sqrt_025 );
		regy = ((data << (15 - n - 2)) - cordic_16_sqrt_025 );
	} else {
		regx = ((data << (15 - n - 1)) + cordic_16_sqrt_025 );
		regy = ((data << (15 - n - 1)) - cordic_16_sqrt_025 );
	}

	cordic_x_data_word_write(regx);
	cordic_y_data_word_write(regy);
	cordic_z_data_word_write(0);

	cordic_start_vect();

	while(!cordic_polling()){}
	cordic_clear();

	if(even){
		temp = cordic_cos_half_word_read();
		result = temp / cordic_16_sqrt_div;
		result = result * 1.2075;
		result = result * (1 << n/2);
	} else {
		temp = cordic_cos_half_word_read();
		result = temp / cordic_16_sqrt_div;
		result = result * 1.2075;
		result = result * (1 << (n-1)/2);
	}

	return (result);

}
