/*
 * interrupt_handlers.c
 *
 *  Created on: 28 mag 2020
 *      Author: Federico.Pozzana
 */

#include "interrupt_handlers.h"
#include "riscv_1_gp_01.h"
#include "core_rv32.h"

void enable_interrupt(void) {
	IER = 0xFFFFFFFF;
}

void disable_interrupt(void) {
	IER = 0x00000000;
}

void enable_event(void) {
	EER = 0xFFFFFFFF;
}

void disable_event(void) {
	EER = 0x00000000;
}

//ICP = ICP | something => clear interrupt, not global (interrupt clear pending)

void  __attribute__((interrupt("machine")))
PowerFail_Handler(void) {
   // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000001;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
BusError_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000002;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_02_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000004;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_03_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000008;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_04_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000010;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_05_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000020;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_06_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000040;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_07_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000080;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_08_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000100;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_09_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000200;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_10_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000400;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_11_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00000800;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_12_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00001000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_13_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00002000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_14_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00004000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_15_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00008000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_16_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00010000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_17_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00020000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_18_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00040000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_19_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00080000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_20_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00100000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_21_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00200000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_22_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00400000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_23_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x00800000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_24_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x01000000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_25_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x02000000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_26_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x04000000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_27_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x08000000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_28_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x10000000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_29_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x20000000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_30_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x40000000;
	IER = 0xFFFFFFFF;
}

void  __attribute__((interrupt("machine")))
IRQ_31_Handler(void) {
  // Clear flag if it happens to be set
	IER = 0x00000000;
	ICP = ICP | 0x80000000;
	IER = 0xFFFFFFFF;
}
