/*
 * interrupt_handlers.h
 *
 *  Created on: 28 mag 2020
 *      Author: Federico.Pozzana
 */

#ifndef INTERRUPT_HANDLERS_H_
#define INTERRUPT_HANDLERS_H_

#include "pulpino.h"

#define interrupt_enable                                 ( INTERRUPT_BASE_ADDR         )
#define interrupt_pending                                ( INTERRUPT_BASE_ADDR + 0x4   )
#define interrupt_set_pending                            ( INTERRUPT_BASE_ADDR + 0x8   )
#define interrupt_clear_pending                          ( INTERRUPT_BASE_ADDR + 0xC   )
#define eevent_enable                                     ( INTERRUPT_BASE_ADDR + 0x10  )
#define eevent_pending                                    ( INTERRUPT_BASE_ADDR + 0x14  )
#define eevent_set_pending                                ( INTERRUPT_BASE_ADDR + 0x18  )
#define eevent_clear_pending                              ( INTERRUPT_BASE_ADDR + 0x1C  )
#define sleep_control                                    ( INTERRUPT_BASE_ADDR + 0x20  )
#define ssleep_status                                     ( INTERRUPT_BASE_ADDR + 0x24  )

#define IER 							                 REG(interrupt_enable)
#define IPR 							                 REG(interrupt_pending)
#define ISP 							                 REG(interrupt_set_pending)
#define ICP 							                 REG(interrupt_clear_pending)
#define EER 							                 REG(eevent_enable)
#define EPR 							                 REG(eevent_pending)
#define ESP 							                 REG(eevent_set_pending)
#define ECP 							                 REG(eevent_clear_pending)
#define SCR 							                 REG(sleep_control)
#define SSR 							                 REG(ssleep_status)


void enable_interrupt(void);
void enable_event(void);

void disable_interrupt(void);
void disable_event(void);

void clear_interrupt(int interrupt);

#endif /* INTERRUPT_HANDLERS_H_ */
