#ifndef PULPINO_H
#define PULPINO_H

#define PULPINO_BASE_ADDR             0x0

/** SOC PERIPHERALS */
#define SOC_PERIPHERALS_BASE_ADDR     ( PULPINO_BASE_ADDR + 0x40000000 )
#define SOC_PERIPHERALS_END_TEST_ADDR ( PULPINO_BASE_ADDR + 0x40010000 )
#define SOC_PERIPHERALS_END_ADDR      ( PULPINO_BASE_ADDR + 0x400FFFFF )

#define RF_BASE_ADDR                  ( SOC_PERIPHERALS_BASE_ADDR + 0x0000 )

#define INTERRUPT_BASE_ADDR           ( PULPINO_BASE_ADDR + 0x40036000 )
#define INTERRUPT_END_ADDR            ( PULPINO_BASE_ADDR + 0x400363FF )

/** TEST REGS */
#define CHECK_REG_TEST                ( SOC_PERIPHERALS_BASE_ADDR + 0x8000 )
#define CHECK_REG_INPUT               ( SOC_PERIPHERALS_BASE_ADDR + 0x8004 )

#define test_check                    REG(CHECK_REG_TEST)
#define test_input                    REG(CHECK_REG_INPUT)

/** PERIPHERALS START ADDRESS */
#define UART_BASE_ADDR                ( SOC_PERIPHERALS_BASE_ADDR + 0x4000 )
#define CPU_FREQ_HZ                   10000000
#define BAUD_RATE                     9600
#define UART_DIV                      CPU_FREQ_HZ/BAUD_RATE

#define SPI_BASE_ADDR                 ( SOC_PERIPHERALS_BASE_ADDR + 0x2000 )

#define I2C_BASE_ADDR                 ( SOC_PERIPHERALS_BASE_ADDR + 0x1000 )

#define CORDIC_BASE_ADDR              ( SOC_PERIPHERALS_BASE_ADDR + 0x0800 )

/** Registers and pointers */
#define REGP(x) ((volatile unsigned int*)(x))
#define REG(x) (*((volatile unsigned int*)(x)))
#define REGP_8(x) (((volatile uint8_t*)(x)))

#define BYTE unsigned short
#define HALF_WORD unsigned int
#define WORD unsigned long long

#define sBYTE signed short
#define sHALF_WORD signed int
#define sWORD signed long long

/** CORDIC CONSTANTS */
#define cordic_8_const 39
#define cordic_16_const 9948
#define cordic_32_const 651976036

#define cordic_8_div 64.0
#define cordic_16_div 16384.0
#define cordic_32_div 1073741824.0

#define cordic_16_sqrt_025 2048
#define cordic_16_sqrt_div 8192.0
#define cordic_16_sqrt_scaling_div 0.000073699951171875

#define INSTRUCTION_LENGHT 16

#endif /* PULPINO_H_ */
