/*
 ============================================================================
 Name        : main.c
 Author      : federico
 Version     :
 Copyright   : 
 Description : I2C drivers
 ============================================================================
 */

/* interrupt libraries inclusion */
#include "interrupt_handlers.h"
#include "riscv_1_gp_01.h"
#include "core_rv32.h"

#include "i2c.h"
#include "i2c2.h"

int
main(void)
{
	enable_interrupt();
	enable_event();
	__enable_irq();

/////////////////////////////////////////////////////////////////////////////
/*
	test_check = 0x01;

	i2c_enable();
	i2c_master_mode_enable();
	i2c_set_timeout(0x0400);
	i2c_clock_low(0x0040);
	i2c_clock_high(0x0040);

	i2c2_enable();
	i2c2_master_mode_disable();
	i2c2_slave0_address(0x01);
	i2c2_slave0_address_enabled();
	i2c2_clock_low(0x0040);
	i2c2_clock_high(0x0040);
*/
/////////////////////////////////////////////////////////////////////////////
/*
	i2c_enable();
	i2c_master_mode_disable();
	i2c_slave0_address(0x01);
	i2c_slave0_address_enabled();
	i2c_clock_low(0x0040);
	i2c_clock_high(0x0040);

	BYTE test0;
	BYTE test1;
	BYTE test2;
*/
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////I2C master firmware/////////////////////////////////////
/////////////////////master write////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

	test_check = 0x01;

	i2c_enable();
	i2c_master_mode_enable();
	i2c_set_timeout(0x0400);
	i2c_clock_low(0x0001);
	i2c_clock_high(0x0001);


/////////////////////master read/////////////////////////////////////////////
/*
	i2c_enable();
	i2c_master_mode_enable();
	i2c_set_timeout(0x0400);
	i2c_clock_low(0x0040);
	i2c_clock_high(0x0040);

	i2c_set_rx_bytes_count(0x01);
	i2c_stop_irq_enabled();

	for(int i = 0; i < 1000; i++){}
	i2c_master_read(0x01, 0x01);
*/
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////I2C slave firmware//////////////////////////////////////
/////////////////////master write////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/*
	i2c_enable();
	i2c_master_mode_disable();
	i2c_slave0_address(0x01);
	i2c_slave0_address_enabled();
	i2c_clock_low(0x0040);
	i2c_clock_high(0x0040);

	i2c_stop_irq_enabled();

	for(int i = 0; i < 1000;  i++){}

	test_check ^= 0x01;
	test_check ^= 0x01;
*/

/////////////////////master read/////////////////////////////////////////////
/*
	i2c_enable();
	i2c_master_mode_disable();
	i2c_slave0_address(0x01);
	i2c_slave0_address_enabled();
	i2c_clock_low(0x0040);
	i2c_clock_high(0x0040);

	i2c_slave_address_match_irq_enabled();
*/
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/*
	BYTE test0;
	BYTE test1;
	BYTE test2;
	BYTE send0 = 0x01;
	BYTE send1 = 0xfe;
	BYTE send2 = 0x44;

	int num_loop = 100;
	int test_passed = 0;

	for(int j = 0; j < num_loop; j++){

		i2c_master_write_half_word(0x01, send0, send1, send2);
		while(!i2c2_is_stop_irq()){}
		i2c2_clear_irq_stop();
		test0 = i2c2_read_data();
		test1 = i2c2_read_data();
		test2 = i2c2_read_data();
		i2c2_rx_fifo_flush();
		if(test0 == send0 && test1 == send1 && test2 == send2){
			test_passed++;
		}

		send0 += 0x12;
		if(send0 > 0xff){
			send0 = 0x00;
		}
		send1 += 0x23;
		if(send1 > 0xff){
			send1 = 0x00;
		}
		send2 += 0x09;
		if(send2 > 0xff){
			send2 = 0x00;
		}
	}

	i2c_set_rx_bytes_count(0x03);

	send0 = 0x20;
	send1 = 0x30;
	send2 = 0x00;

	for(int t = 0; t < num_loop; t++){
		i2c_master_read(0x01, 0x02);

		while(!i2c2_is_slave_read_address_match_irq()){}
		i2c2_clear_irq_slave_read_address_match();
		i2c2_write_data(send0);
		i2c2_write_data(send1);
		i2c2_write_data(send2);

		while(!i2c_is_stop_irq()){}
		i2c_clear_irq_stop();

		test0 = i2c_read_data();
		test1 = i2c_read_data();
		test2 = i2c_read_data();

		if(test0 == send0 && test1 == send1 && test2 == send2){
			test_passed++;
		}

		send0 += 0x05;
		if(send0 > 0xff){
			send0 = 0x00;
		}
		send1 += 0x54;
		if(send1 > 0xff){
			send1 = 0x00;
		}
		send2 += 0x01;
		if(send2 > 0xff){
			send2 = 0x00;
		}

	}

	//pass/fail check
	if(test_passed == 2*num_loop){
		test_check = 0x02;
	} else {
		test_check = 0x00;
	}

*/
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

	//i2c_master_write_half_word(0x01, 0x02, 0x11, 0x88);
	//test = i2c2_read_data();
	//i2c2_rx_fifo_flush();

	//i2c_master_write_half_word(0x01, 0x01, 0xbb, 0x44);

	while(1){
/*
		while(!i2c_is_stop_irq()){}
		i2c_clear_irq_stop();
		test0 = i2c_read_data();
		test1 = i2c_read_data();
		test2 = i2c_read_data();
		i2c_rx_fifo_flush();
		if(test0 == 0x01 && test1 == 0xbb && test2 == 0x44){
			test_check ^= 0x01;
		}

		while(!i2c_is_slave_read_address_match_irq()){}
		i2c_clear_irq_slave_read_address_match();
		i2c_write_data(test0);
		i2c_write_data(test1);
		i2c_write_data(test2);
*/

		/*
		i2c_master_write_half_word(0x01, 0x01, 0xbb, 0x44);

		while(!i2c2_is_stop_irq()){}
		i2c2_clear_irq_stop();
		test0 = i2c2_read_data();
		test1 = i2c2_read_data();
		test2 = i2c2_read_data();
		i2c2_rx_fifo_flush();
		if(test0 == 0x01 && test1 == 0xbb && test2 == 0x44){
			test_check ^= 0x01;
		}

		i2c_set_rx_bytes_count(0x03);
		i2c_master_read(0x01, 0x02);

		while(!i2c2_is_slave_read_address_match_irq()){}
		i2c2_clear_irq_slave_read_address_match();
		i2c2_write_data(test0);
		i2c2_write_data(test1);
		i2c2_write_data(test2);
		*/
	}
}
